program TCP2Serial;

	uses
		MyForeBackground,Windows,Types,MySystemGlobals,Traps,
		Connections,CTBUtilities,CommResources,TCPStuff,ToolUtils;

var
	quitNow:boolean;

	procedure WNE;
	var
		dummy:boolean;
		er:EventRecord;
	begin
		dummy:=WaitNextEvent(everyEvent,er,10,nil);
		if (er.what=keyDown) & (BAND(er.modifiers,cmdKey)<>0) & (BAND(er.message,$FF)=ord('q')) then begin
			quitNow:=true;
		end;
	end;
	
	function GetGlobalStr(n:integer):str255;
	var
		s:str255;
	begin
		GetIndString(s,128,n);
		GetGlobalStr:=s;
	end;
	
	procedure Process(ch:ConnHandle);
	var
		err,oerr:OSErr;
		tcpc:TCPConnectionPtr;
		count:longInt;
		buffer:packed array[1..128] of byte;
		timeout:longInt;
		available:CMBufferSizes;
		statflags:CMStatFlags;
		flags:CMFlags;
		port:longInt;
	begin
		StringToNum(GetGlobalStr(3),port);
		err := TCPPassiveOpen (tcpc, 0,port,0,0,nil);
		if err=noErr then begin
			while not quitNow & (TCPState(tcpc) in [T_WaitingForOpen, T_Listening, T_Opening]) do begin
				WNE;
			end;
		  	err:=CMOpen(ch,false,nil,0);
		  	if err=noErr then begin
				while not quitNow and ((TCPState(tcpc)=T_Established) or (TCPCharsAvailable(tcpc)>0)) do begin
					WNE;
					count:=TCPCharsAvailable(tcpc);
					if count>0 then begin
						if count>SizeOf(buffer) then begin
							count:=SizeOf(buffer);
						end;
						err:=TCPRawReceiveChars (tcpc,@buffer,count);
						if err=noErr then begin
							err:=CMWrite(ch,@buffer,count,cmData,false,nil,0,0);
						end;
					end;
					if err=noErr then begin
						err:=CMStatus(ch,available,statflags);
						if (err=noErr) then begin
							count:=available[cmDataIn];
							if count>0 then begin
								if count>SizeOf(buffer) then begin
									count:=SizeOf(buffer);
								end;
								err:=CMRead(ch,@buffer,count,cmData,false,nil,0,flags);
								if err=noErr then begin
									err:=TCPSendAsync (tcpc,@buffer,count,true,@oerr);
									if err=noErr then begin
										while not quitNow and (oerr=1) do begin
											WNE;
										end;
										err:=oerr;
									end;
								end;
							end;
						end;
					end;
				end; { while }
		  		err:=CMClose(ch,false,nil,0,false);
				err:=TCPClose (tcpc,nil);
				timeout:=TickCount+60*10;
				while not quitNow & (timeout<TickCount) & (TCPState(tcpc)<>T_Closed) do begin
					err:=TCPFlush (tcpc);
					WNE;
				end;
			end;
			err:=TCPRelease (tcpc);
		end;
	end;

var
	err:OSErr;
	proc:integer;
	ch:ConnHandle;
	desiredSizes:CMBufferSizes;
	config:Ptr;
	where:Point;
	s:str255;
begin
	InitInForeOrBackground (0,0,0,0);
	InitSystemGlobals;
	quitNow:=false;
	if NGetTrapAddress($8B,OSTrap)<>NGetTrapAddress($9F,OSTrap) then begin
		err:=TCPInit;
		if err=noErr then begin
			err:=InitCRM;
			if err=noErr then begin
				err:=InitCTBUtilities;
			end;
			if err=noErr then begin
				err:=InitCM;
			end;
		  if err=noErr then begin
		  	proc:=CMGetProcID(GetGlobalStr(1));
		  	if proc<>-1 then begin
		  		desiredSizes[cmRsrvIn]:=0;
		  		desiredSizes[cmRsrvOut]:=0;
		  		ch:=CMNew(proc,cmData+cmNoMenus+cmQuiet,desiredSizes,0,0);
		  		if ch<>nil then begin
		  			s:=concat(GetGlobalStr(2),chr(0));
		  			err:=CMSetConfig(ch,@s[1]);
		  			if false then begin
		  				where.h:=40;
		  				where.v:=40;
		  				err:=CMChoose(ch,where,nil);
		  				config:=CMGetConfig(ch);
		  				Debugger;
		  				err:=noErr;
		  			end;
		  			while not quitNow do begin
			  			Process(ch);
			  		end;
		  			CMDispose(ch);
		  		end;
		  	end;
		  end;
	  	TCPFinish;
	  end;
  end;
end. (* TCP2Serial *)
