unit MyCallProc;

interface

	uses
		MixedMode;

	const
		uppPascal0ProcInfo = kPascalStackBased + $10*kNoByteCode;
		uppPascal04ProcInfo = kPascalStackBased + $10*kNoByteCode + $40* kFourByteCode;
		uppPascal022ProcInfo = kPascalStackBased + $10*kNoByteCode + $40* kTwoByteCode + $100* kTwoByteCode;
		uppPascal0444ProcInfo = kPascalStackBased + $10*kNoByteCode + $40* kFourByteCode + $100* kFourByteCode + 1024* kFourByteCode;
		uppPascal02244ProcInfo = kPascalStackBased + $10*kNoByteCode + $40* kTwoByteCode + $100* kTwoByteCode + $400* kFourByteCode + $1000* kFourByteCode;
		uppPascal2ProcInfo = kPascalStackBased + $10*kTwoByteCode;
		uppPascal24ProcInfo = kPascalStackBased + $10*kTwoByteCode + $40* kFourByteCode;

	procedure CallPascal0 (proc: UniversalProcPtr);
{$IFC not GENERATINGPOWERPC}
	inline
		$205F, $4E90;
{$ENDC}

	function NewPascal0Proc(userRoutine: ProcPtr): UniversalProcPtr;
{$IFC not GENERATINGPOWERPC }
	inline
		$2E9F;
{$ENDC}

	procedure CallPascal04 (p1:univ SInt32; proc: UniversalProcPtr);
{$IFC not GENERATINGPOWERPC}
	inline
		$205F, $4E90;
{$ENDC}

	function NewPascal04Proc(userRoutine: ProcPtr): UniversalProcPtr;
{$IFC not GENERATINGPOWERPC }
	inline
		$2E9F;
{$ENDC}

	procedure CallPascal022 (p1:univ SInt16; p2: univ SInt16; proc: UniversalProcPtr);
{$IFC not GENERATINGPOWERPC}
	inline
		$205F, $4E90;
{$ENDC}

	function NewPascal022Proc(userRoutine: ProcPtr): UniversalProcPtr;
{$IFC not GENERATINGPOWERPC }
	inline
		$2E9F;
{$ENDC}

	procedure CallPascal0444 (p1:univ SInt32; p2:univ SInt32; p3:univ SInt32; proc: UniversalProcPtr);
{$IFC not GENERATINGPOWERPC}
	inline
		$205F, $4E90;
{$ENDC}

	function NewPascal0444Proc(userRoutine: ProcPtr): UniversalProcPtr;
{$IFC not GENERATINGPOWERPC }
	inline
		$2E9F;
{$ENDC}

	procedure CallPascal02244 (p1:univ SInt16; p2: univ SInt16; p3:univ SInt32; p4:univ SInt32;  proc: UniversalProcPtr);
{$IFC not GENERATINGPOWERPC}
	inline
		$205F, $4E90;
{$ENDC}

	function NewPascal02244Proc(userRoutine: ProcPtr): UniversalProcPtr;
{$IFC not GENERATINGPOWERPC }
	inline
		$2E9F;
{$ENDC}

	function CallPascal2(proc: UniversalProcPtr):SInt16;
{$IFC not GENERATINGPOWERPC}
	inline
		$205F, $4E90;
{$ENDC}

	function NewPascal2Proc(userRoutine: ProcPtr): UniversalProcPtr;
{$IFC not GENERATINGPOWERPC }
	inline
		$2E9F;
{$ENDC}

	function CallPascal24(p1:univ SInt32; proc: UniversalProcPtr):SInt16;
{$IFC not GENERATINGPOWERPC}
	inline
		$205F, $4E90;
{$ENDC}

	function NewPascal24Proc(userRoutine: ProcPtr): UniversalProcPtr;
{$IFC not GENERATINGPOWERPC }
	inline
		$2E9F;
{$ENDC}

implementation

{$IFC GENERATINGPOWERPC}

	procedure CallPascal0 (proc: UniversalProcPtr);
		var
			junk_long:longInt;
	begin
		junk_long:= CallUniversalProc(proc, uppPascal0ProcInfo);
	end;

	function NewPascal0Proc(userRoutine: ProcPtr): UniversalProcPtr;
	begin
		NewPascal0Proc:=NewRoutineDescriptor(userRoutine,uppPascal0ProcInfo,GetCurrentISA);
	end;

	procedure CallPascal04 (p1:univ SInt32; proc: UniversalProcPtr);
		var
			junk_long:longInt;
	begin
		junk_long:= CallUniversalProc(proc, uppPascal04ProcInfo, p1);
	end;

	function NewPascal04Proc(userRoutine: ProcPtr): UniversalProcPtr;
	begin
		NewPascal04Proc:=NewRoutineDescriptor(userRoutine,uppPascal04ProcInfo,GetCurrentISA);
	end;

	procedure CallPascal022 (p1:univ SInt16; p2: univ SInt16; proc: UniversalProcPtr);
		var
			junk_long:longInt;
	begin
		junk_long:= CallUniversalProc(proc, uppPascal022ProcInfo, p1,p2);
	end;

	function NewPascal022Proc(userRoutine: ProcPtr): UniversalProcPtr;
	begin
		NewPascal022Proc:=NewRoutineDescriptor(userRoutine,uppPascal022ProcInfo,GetCurrentISA);
	end;

	procedure CallPascal0444 (p1:univ SInt32; p2:univ SInt32; p3:univ SInt32; proc: UniversalProcPtr);
		var
			junk_long:longInt;
	begin
		junk_long:= CallUniversalProc(proc, uppPascal0444ProcInfo, p1,p2,p3);
	end;

	function NewPascal0444Proc(userRoutine: ProcPtr): UniversalProcPtr;
	begin
		NewPascal0444Proc:=NewRoutineDescriptor(userRoutine,uppPascal0444ProcInfo,GetCurrentISA);
	end;

	procedure CallPascal02244 (p1:univ SInt16; p2: univ SInt16; p3:univ SInt32; p4:univ SInt32;  proc: UniversalProcPtr);
		var
			junk_long:longInt;
	begin
		junk_long:= CallUniversalProc(proc, uppPascal02244ProcInfo, p1,p2,p3,p4);
	end;

	function NewPascal02244Proc(userRoutine: ProcPtr): UniversalProcPtr;
	begin
		NewPascal02244Proc:=NewRoutineDescriptor(userRoutine,uppPascal02244ProcInfo,GetCurrentISA);
	end;

	function CallPascal2(proc: UniversalProcPtr):SInt16;
	begin
		CallPascal24:= CallUniversalProc(proc, uppPascal24ProcInfo);
	end;

	function NewPascal2Proc(userRoutine: ProcPtr): UniversalProcPtr;
	begin
		NewPascal2Proc:=NewRoutineDescriptor(userRoutine,uppPascal2ProcInfo,GetCurrentISA);
	end;

	function CallPascal24(p1:univ SInt32; proc: UniversalProcPtr):SInt16;
	begin
		CallPascal24:= CallUniversalProc(proc, uppPascal24ProcInfo, p1);
	end;

	function NewPascal24Proc(userRoutine: ProcPtr): UniversalProcPtr;
	begin
		NewPascal24Proc:=NewRoutineDescriptor(userRoutine,uppPascal24ProcInfo,GetCurrentISA);
	end;
	
{$ENDC}

end.
